/*
 *  
 *  $Id: panelconfiguracionpermisos.h 3526 2011-03-16 19:56:19Z carlos $
 *  Ginkgo CADx Project
 *
 *  Copyright 2008-10 MetaEmotion S.L. All rights reserved.
 *  http://ginkgo-cadx.com
 *
 *  This file is licensed under LGPL v3 license.
 *  See License.txt for details
 *
 *
 */
#pragma once
#include <api/iconfiguracion.h>
#include "panelesconfiguracionginkgobase.h"
#include <string>
#include <vector>

namespace GNC {
	namespace GUI {

		class PanelConfiguracionPermisos: public PanelConfiguracionPermisosBase, public IPasoConfiguracion
		{
			public:
				PanelConfiguracionPermisos(wxWindow* pParent,IDialogoConfiguracion* pDialogo);
				~PanelConfiguracionPermisos();

				void Recargar();

				//region "Metodos de IPasoConfiguracion"
				wxWindow* GetPanel();

				std::string GetTitle();

				std::string GetCabecera();

				bool Validar();

				bool Guardar();

				void Exportar(wxXmlNode* pNodo);

				void Importar(wxXmlNode* pNodo);
				//endregion


			protected:
				virtual void OnListaPermisosDClick(wxTreeEvent& event);
				virtual void OnListaPermisosChangeSelection(wxTreeEvent& event);

				virtual void OnSetActive(wxCommandEvent &event);

				virtual void OnNuevoClick(wxCommandEvent &event);

				virtual void OnEditarClick(wxCommandEvent &event);

				virtual void OnEliminarClick(wxCommandEvent &event);

				virtual void OnTextoCambiado(wxCommandEvent &event );

				virtual void OnPropiedadCambiada();

				void OnSize(wxSizeEvent &);

				typedef struct TipoProfile{
					std::string nombre;
					std::string xml;
					bool aplicar;
					TipoProfile() {}

					TipoProfile(const std::string& nombre, const std::string& xml, bool aplicar)
					{
						this->nombre = nombre;
						this->xml = xml;
						this->aplicar = aplicar;
					}
				} TipoProfile;
				typedef std::vector <TipoProfile> TipoListaProfiles;
				TipoListaProfiles m_profiles;
				bool m_permisosCambiados;

		};
	}
}
