/*
 *  
 *  $Id: dialogoconfirmacioneliminar.h 3066 2010-12-21 10:10:14Z carlos $
 *  Ginkgo CADx Project
 *
 *  Copyright 2008-10 MetaEmotion S.L. All rights reserved.
 *  http://ginkgo-cadx.com
 *
 *  This file is licensed under LGPL v3 license.
 *  See License.txt for details
 *
 *
 */
#pragma once
#include "panelhistorial2base.h"

//----------DIALOGO CONFIRMAR ELIMINAR...-------------
namespace GNC {
	namespace GUI {
		class DialogoConfirmacionEliminar:public DialogoConfirmacionEliminarBase {
		public:
			typedef enum {
				TR_Eliminar,
				TR_Cancelar
			} TipoResultado;

			DialogoConfirmacionEliminar(wxWindow* parent, const wxString& label):DialogoConfirmacionEliminarBase(parent){
				m_pLabelEliminar->SetLabel(m_pLabelEliminar->GetLabel() + label + _(" from History?"));
				m_resultado = TR_Cancelar;
				Layout();
				SetSize(GetBestSize());
				Layout();
			};

			~DialogoConfirmacionEliminar(){
			};

			void OnEliminarClick(wxCommandEvent &) {
				m_resultado = TR_Eliminar;
				Close();
			}

			void OnCancelarClick(wxCommandEvent &) {
				m_resultado = TR_Cancelar;
				Close();
			}

			const TipoResultado& GetResultado() const{
				return m_resultado;
			}
		protected:
			TipoResultado m_resultado;
		};
	};
};
