/*
 *  
 *  $Id: wgradiente.h 3535 2011-03-18 17:57:05Z carlos $
 *  Ginkgo CADx Project
 *
 *  Copyright 2008-10 MetaEmotion S.L. All rights reserved.
 *  http://ginkgo-cadx.com
 *
 *  This file is licensed under LGPL v3 license.
 *  See License.txt for details
 *
 *
 */
#pragma once
#include <api/iwidgets.h>
#include <api/observers/iwidgetsobserver.h>
#include <api/icontroladoreventos.h>
#include <vector>
#include <list>
#include <set>

#ifdef __DEPRECATED
#undef __DEPRECATED
#endif
#include <vtkSmartPointer.h>
#include <vtkImageData.h>



namespace GNC {
	namespace GCS {

		namespace Widgets {

			class Data;

			class WGradienteBuilder : public GNC::GCS::Widgets::IWidgetBuilder, public GNC::GCS::Widgets::IObservadorWidget {
			public:

				WGradienteBuilder(GNC::GCS::IWidgetsManager* pManager, vtkImageData* imgData, long vid, long gid);

				~WGradienteBuilder();

				virtual void OnWidgetDestruido(IWidget*);

				virtual void OnMouseEvents(GNC::GCS::Eventos::EventoRaton&);

				virtual void OnKeyEvents(GNC::GCS::Eventos::EventoTeclado&);

				virtual void Render(GNC::GCS::Contexto3D* c);

			protected:
				vtkSmartPointer<vtkImageData> m_pImgData;
				GNC::GCS::Vector              m_PosicionCursor;
				Estado                        m_Estado;
				Data*                         m_Data;

			};
		}
	}
}
